// @flow
import type { 
  VUE_INSTANCE,
  COMPONENT_OBJECT_OPTION
 } from './type'

// 将methods指向vue父组件实例
export default function (vueInstance: VUE_INSTANCE, methods: Object): Object | void {
    if (!methods) return
    const newMethod = {}
    Object.keys(methods).forEach(key => Reflect.set(newMethod, key, vueInstance[methods[key]]))
    return newMethod
}