// @flow
import type { 
  VUE_INSTANCE,
  COMPONENT_OBJECT_OPTION
 } from './type'

// 将props指向vue父组件实例
export default function (vueInstance: VUE_INSTANCE, props: Object): Object | void {
    if (!props) return
    const newProps = {}
    Object.keys(props).forEach(key => Reflect.set(newProps, key, vueInstance[props[key]]))
    return newProps
}