// @flow
import type { CONSTRUCTOR_OPTION } from './type'
import getProps from './props'
import getMethods from './methods'
import getContainerStyle from './style'
import defineInstanceProperty from './properties'
// 生成vue render方法
export default function (option: CONSTRUCTOR_OPTION): Function {
  const components = option.component

  function render (vueInstance, createElement, components, option) {
    if (option) {
      const { prop, method } = components.option
      return createElement(components, {
        props: getProps(vueInstanceSelf, prop),
        on: getMethods(vueInstanceSelf, method)
      }) // 若存在组件配置
    } else return createElement(components) // 不存在组件配置
  }

  return function (createElement: Function) {
    const vueInstanceSelf = this // this指向vue实例
    defineInstanceProperty(vueInstanceSelf)
    return Array.isArray(components) 
    ? createElement('div', getContainerStyle(option.style), components.map(({ components, option }) => render(vueInstanceSelf, createElement, components, option)))
    : render(vueInstanceSelf, createElement, components.components, components.option)
  }
}